<template>
  <div
    :class="[
      'v-input',
      `type-${type}`,
      {
        disabled,
        focused,
        large,
        'show-suggestion': showSuggestion,
        [`status-${status}`]: status,
      },
    ]"
    @click="focus()"
  >
    <div class="content">
      <slot name="left" />

      <div class="input-wrapper">
        <Component
          :is="type === 'textarea' ? type : 'input'"
          ref="input"
          class="input"
          :type="type"
          :value.prop="valueModel"
          :placeholder="placeholder"
          :disabled="disabled"
          v-bind="$attrs"
          v-on="$listeners"
          @input="valueModel = $event.currentTarget.value"
          @focus="onFocus"
          @blur="onBlur"
          @keydown.tab="onKeyTab"
        />

        <input
          v-if="showSuggestion"
          class="input suggestion"
          :value="suggestion"
          disabled
        >
      </div>

      <slot name="right" />

      <!-- Focus animation -->
      <div class="border" />
    </div>
  </div>
</template>

<script lang="ts">
import {
  Component, Vue, Model, Prop,
} from 'nuxt-property-decorator';

@Component({
  inheritAttrs: false,
})
export default class VInput extends Vue {
  @Model('update', { type: [String, Number] })
  readonly value!: string|number|null

  @Prop({ type: [String, Number], default: null })
  readonly suggestion!: string|number|null

  @Prop({ type: String, default: 'text' })
  readonly type!: string|number|null

  @Prop(String)
  readonly placeholder!: string

  @Prop(String)
  readonly status!: string

  @Prop(Boolean)
  readonly selectAll!: boolean

  @Prop(Boolean)
  readonly disabled!: boolean

  @Prop(Boolean)
  readonly large!: boolean

  focused = false

  get valueModel() {
    return this.value;
  }

  set valueModel(val) {
    if (this.disabled) return;

    this.$emit('update', val);
  }

  get showSuggestion() {
    return this.suggestion !== null && this.suggestion !== this.value && this.focused && this.value;
  }

  focus() {
    const { input } = this.$refs;
    (input as HTMLInputElement).focus();
    if (this.selectAll) {
      (input as HTMLInputElement).setSelectionRange(0, (input as HTMLInputElement).value.length);
    }
  }

  onBlur(event: Event) {
    this.focused = false;
    this.$emit('blur', event);
  }

  onFocus(event: Event) {
    this.focused = true;
    this.$emit('focus', event);
  }

  onKeyTab(event: Event) {
    if (this.showSuggestion) {
      this.valueModel = this.suggestion;
      event.preventDefault();
      event.stopPropagation();
    }
  }
}
</script>

<style lang="stylus">
.v-input
  display inline-block
  vertical-align middle
  box-sizing border-box
  width auto
  min-width 200px
  margin 6px 8px
  > .content
    position relative
    display flex
    flex-direction row
    align-items center
    justify-content center
    padding 0 10px
    background #fafafa
    border 1px solid #ced4da
    color #2c3e50
    border-radius 3px
    transition background .3s
    > .input-wrapper
      position relative
      width 0
      flex auto 1 1
      > .input
        position relative
        z-index 1
        font-family inherit
        font-size 14px
        line-height 14px
        color @color
        padding 0
        width 100%
        display block
        border none
        background transparent
        outline none
        &:not(textarea)
          height 30px
        &::placeholder
          color #829ebb
        &::-moz-focus-inner
          border 0
        &textarea
          padding 8px 10px
          resize vertical
          min-height 30px
          box-sizing border-box
          line-height 18px
      > .suggestion
        position absolute
        z-index 0
        top 0
        left 0
        overflow hidden
        white-space nowrap
        text-overflow ellipsis
        color #829ebb
        pointer-events none
    > .border
      position absolute
      bottom -1px
      left 30%
      right @left
      background #42b983
      opacity 0
      height 2px
      pointer-events none
      transition left .15s, right .15s, opacity .15s
  &.type-textarea
    > .content
      padding 0
  &.show-suggestion
    > .content > .input-wrapper > .input
      &::placeholder
        color transparen
  &.focused
    > .content
      background-color white
      > .border
        left 0
        right @left
        opacity 1
  &.large
    > .content
      padding 0 14px
      > .input-wrapper > .input
        font-size 16px
        &:not(textarea)
          height 42px
</style>
